app.controller('listCtrl',function($scope){
  
  $scope.activeList = [];   //正在进行的考试
  $scope.overList = []  //已经结束的考试
  $scope.showActive = true;   //显示正在进行的活动
  $scope.hasMore = false;
  $scope.hasEndMore = false;
  $scope.noExam = false;
  $scope.noEndExam = false;
  
  var minutes = 5;
  
  var sbe = new ScrollBottomEvent(document.getElementById('examList'), 
                  getActiveList, 1000);
  
  var endSbe = new ScrollBottomEvent(document.getElementById('overList'), 
                  getOverList, 1000);
  
  var pageSize = 20;
  var pageNum = 1;
  var endPageNum = 1;
  
  $scope.init = function() {
    mui.plusReady(init);
  }
  
  
  $scope.joinExam = function(item) {
    openWindow('startExam.html?type=exam&examId=' + item.id);
  }
  
  $scope.viewResult = function(item) {
    openWindow('report.html?examId=' + item.id);
  }
  
  $scope.refreshExam = function() {
    pageNum = 1;
    endPageNum = 1;
    
    $scope.activeList = [];   //正在进行的考试
    $scope.overList = [];   //已经结束的考试
    $scope.hasMore = false;
    $scope.hasEndMore = false;
    $scope.noExam = false;
    $scope.noEndExam = false;
    
    getActiveList();
    getOverList();
  }
  
  function init() {
    initPage();
    getActiveList();
    getOverList();
  }
  
  //获取活动的List
  function getActiveList() {
    mui.ylPost(
      {
        type: 'GetExamList',
        state: '1',
        pageNum: pageNum,
        pageSize: pageSize
      },
      function(data) {
        $scope.activeList = $scope.activeList.concat(data.map(configExam));
     
        if(data.length == pageSize) {
          pageNum++; 
          sbe.end();
          sbe.start();
          $scope.hasMore = true;
        } else {
          sbe.end();
          $scope.hasMore = false;
        }
        if($scope.activeList.length === 0) {
          $scope.noExam = true;
        }
        
        $scope.$apply();
      }
    );
  }
  
  //获取已结束的List
  function getOverList() {
    mui.ylPost(
      {
        type: 'GetExamList',
        state: '2',
        pageSize: pageSize,
        pageNum: endPageNum
      },
      function(data) {
        //console.log(JSON.stringify(data))
        $scope.overList = $scope.overList.concat(data.map(configExam));
        if(data.length == pageSize) {
          endPageNum++; 
          endSbe.end();
          endSbe.start();
          $scope.hasEndMore = true;
        } else {
          sbe.end();
          $scope.hasEndMore = false;
        }
        if($scope.overList.length === 0) {
          $scope.noEndExam = true;
        }
        $scope.$apply();
      }
    );
  }
  
  function configExam(item) {
    item.expand = false;
    
    item.startDate = getChinaTime(item.startDate);
    item.endDate = getChinaTime(item.endDate);

    if(item.myScore == null) {  //null为没有参加考试
    } else {
      item.myScore = item.myScore;
    }
    
    if(item.content == null) {
      item.content = '';
    }
    
    if(item.state == 0 && item.countdown > 0 && item.countdown < minutes * 60) {
      setTimeout(function() {
        item.state = '1';
        $scope.$apply();
      }, item.countdown * 1000);
    }
    
    return item;
  }
  
  function joinExam(item) {
    //考试不在进行中
    if(item.state.toString() != '1') {
      mui.alert('考试未开始！');
      return;
    }
    openWindow('startExam.html?type=exam&examId=' + item.id);
  }
  
  function viewResult(item) {
    if(item.state.toString() != '2') {
      mui.alert('考试未结束，暂时不能查看考试结果！');
      return;
    }
    openWindow('report.html?examId=' + item.id);
  }
  
});

