app.controller('reportCtrl',function($scope){
  
  var search = getSearchArgs();
  
  $scope.init = function() {
    mui.plusReady(init);
  }
  
  $scope.checkAnswer = function() {
    openWindow('startExam.html?type=check&examId=' + search.examId);
  }
  
  function init() {
    initPage();
    var examId = search.examId;
    getMyRecord(examId);
  }
  
  function getMyRecord(examId) {
    //console.log(localStorage.userId);
    //console.log(examId);
    mui.ylPost(
      {
        type: 'GetExamResult',
        examId: examId
      },
      function(data) {
        $scope.record = configRecord(data);
        $scope.$apply();
      }
    );
  }
  
  function configRecord(record) {
    
    record.useTime = parseInt(record.useTime / 60) + '分' + record.useTime % 60 + '秒';
    
    record.score = Math.floor(record.score);
    record.myScore = Math.floor(record.myScore);
    
    record.totalNum = record.tfRight + record.tfError + record.tfNo +
        record.singleRight + record.singleError + record.singleNo +
        record.multipleRight + record.multipleError + record.multipleNo;
        
    record.rightNum = record.tfRight +　record.singleRight + record.multipleRight;
    record.errorNum = record.tfError + record.singleError + record.multipleError;
    record.noNum = record.tfNo + record.singleNo + record.multipleNo;
    
    record.accuracy = Math.floor(record.rightNum / record.totalNum * 100) + '%';
    
    record.tfNum = record.tfRight + record.tfError + record.tfNo;
    
    if(record.tfNum != 0) {
      record.tfAccuracy = (record.tfRight / record.tfNum).toFixed(2) * 100;
    } else {
      record.tfAccuracy = 100;
    }
    
    record.singleNum = record.singleRight + record.singleError + record.singleNo;
    if(record.singleNum != 0) {
      record.singleAccuracy = (record.singleRight / record.singleNum).toFixed(2) * 100;
    } else {
      record.singleAccuracy = 100;
    }
    
    record.multipleNum = record.multipleRight + record.multipleError + record.multipleNo;
    if(record.multipleNum != 0) {
      record.multipleAccuracy = (record.multipleRight / record.multipleNum).toFixed(2) * 100;
    } else {
      record.multipleAccuracy = 100;
    }

    return record;
  }
  
});
