app.controller('examCtrl', function($scope) {
  var search = getSearchArgs();
  var isSubmit = true;
  var ctrlCount = null;
  
  $scope.showQuestion = true;
  $scope.check = false;
  $scope.questions = [];
  $scope.question = {
    option1: '',
    option2: '',
    option3: '',
    option4: '',
    option5: '',
    option6: ''
  };
  $scope.index = 0;
  
  $scope.init = function() {
    mui.plusReady(init);
  }
  
  $scope.showSubmit = function() {
    if(!$scope.check) {
      $scope.unFinishNum = getUnFinishNum();
      postAnswer($scope.question);
    }
    $scope.showQuestion = false;
  }
  
  $scope.goQuestion = function(index, item) {
    if(item.type == '2') {  //单选题
      index += $scope.tfQuestions.length;
    } else if(item.type == '3') { //多选题
      index += $scope.tfQuestions.length + $scope.singleQuestions.length;
    }
    goQuestion(index);
  }
  
  $scope.goNext = function() {
    if(!$scope.check) {
      postAnswer($scope.question);
    }
    nextQuestion();
  }
  
  $scope.goPre = function() {
    if(!$scope.check) {
      postAnswer($scope.question);
    }
    preQuestion();
  }
  
  $scope.choose = function(option) {
    if($scope.check) {
      return;
    }
    var question = $scope.question;
    
    //单选和判断是唯一选的
    if(question.type == '1' || question.type == '2') {
      for(var i = 0; i < 6; i++) {
        question[String.fromCharCode(i + 65)] = false;
      }
    }
    
    $scope.question[option] = !$scope.question[option];
  }
  
  $scope.submitPage = function() {
    submitPage();
  }
  
  function init() {
    initPage();

    $scope.check = search.type == 'check';
    
    var examId = search.examId;
    getPage(examId);
    
    //set mui.back
    mui.back = function() {
      if($scope.showQuestion) {
        plus.webview.close(plus.webview.currentWebview());
      } else {
        $scope.showQuestion = true;
        $scope.$apply();
      }
    }
  }
  
  function getPage(examId) {
    plus.nativeUI.showWaiting('获取试题');
    mui.ylPost(
      {
        type: 'GetExamQuestions',
        examId: examId
      },
      function(data) {
        plus.nativeUI.closeWaiting();
        
        $scope.totalNum = data.total;
        
        if(data.countdown > 0) {
          startCountdown(data.countdown);
        }
        
        $scope.questions = data.tfQuestions.concat(data.singleQuestions, data.multipleQuestions).map(configQuestion);
        $scope.tfQuestions = data.tfQuestions;
        $scope.singleQuestions = data.singleQuestions;
        $scope.multipleQuestions = data.multipleQuestions;
        
        if(data.total === 0) {
          mui.alert('无试题', function() {
            mui.back();
          });
          return;
        }
        $scope.question = $scope.questions[0];
        
        $scope.$apply();
      },
      function(msg) {
        mui.alert(msg, function() {
          mui.back();
        });
      },
      function() {
        mui.alert('服务器异常', function() {
          mui.back();
        })
      }
    );
  }
  
  function nextQuestion() {
    if($scope.index + 1 >= $scope.questions.length) {
      plus.nativeUI.toast('已经是最后一题了！');
      return;
    }
    $scope.question = $scope.questions[++$scope.index];
  }
  
  function preQuestion() {
    if($scope.index == 0) {
      plus.nativeUI.toast('已经是第一题了！');
      return;
    }
    $scope.question = $scope.questions[--$scope.index];
  }
  
  function submitPage() {
    plus.nativeUI.showWaiting('正在提交');
    if(isSubmit) {
      plus.nativeUI.closeWaiting();
      plus.webview.close(plus.webview.currentWebview());
    } else {
      setTimeout(submitPage, 2000);
    }
  }
  
  function goQuestion(idx) { 
    $scope.index = idx;
    $scope.question = $scope.questions[$scope.index];
    $scope.showQuestion = true;
  }
  
  function postAnswer(question) {
    var answer = [];
    for(var i = 0; i < 6; i++) {
      if(question[String.fromCharCode(i + 65)]) {
        answer.push(String.fromCharCode(i + 65));
      }
    }
    //答案一致则不再次提交
    if(question.myAnswer == answer.join(',')) {
      return;
    }
    
    isSubmit = false;
    
    question.myAnswer = answer.join(',');
    
    var nowQ = question;   
    
    mui.ylPost(
      {
        type: 'ToExam',
        examId: search.examId,
        questionsId: question.id,
        answer: answer.join(',')
      },
      function(data) {
        isSubmit = true;
      },
      function(msg) {
        mui.alert(msg, function() {
          mui.back();
        });
      }
    );
  }
  
  function configQuestion(question) {
    
    if(!question.myAnswer) {
      question.myAnswer = '';  
    }
    
    var myAnswer = question.myAnswer.replace('对', 'A');
    myAnswer = myAnswer.replace('错', 'B');
    
    var myAnswerArr = [];

    if(myAnswer != '') {
      myAnswerArr = myAnswer.split(',');   
    }
    
    question.A = false;
    question.B = false;
    question.C = false;
    question.D = false;
    question.E = false;
    question.F = false;
    
    //我选了的
    myAnswerArr.forEach(function(item) {
      question[item.toString()] = true;
    });
    
    if(question.myAnswer != question.answer) {
      question.error = true;
    };
    
    switch(question.type) {
      case '1': 
        question.typeName = '判';
        break;
      case '2':
        question.typeName = '单';
        break;
      case '3':
        question.typeName = '多';
        break;
    }
    
    return question;
  }
  
  function startCountdown(time) {
    var seconds = time % 60 >= 10 ? time % 60 : '0' + time % 60;
    var now = parseInt(time / 60) + '：' + seconds;
    $('#clock').text(now);
    time--;
    if(time > 0) {
      if(time == 10) {
        postAnswer($scope.question);
        plus.nativeUI.toast('只剩10秒了，请及时提交考卷！');
      }
      ctrlCount = setTimeout(function(){startCountdown(time);}, 1000);
    } else {
      mui.alert('考试时间已到,正在为您交卷！', function() {
        submitPage();
      });
    }
  }
  
  function getUnFinishNum() {
    var count = $scope.questions.length;
    $scope.questions.forEach(function(item) {
      if(item.A || item.B || item.C || item.D || item.E || item.F) {
        count--;
      }
    });
    return count;
  }
  
  function listenRuntime() {
    if($scope.check) {
      return;
    }
    //做题时才需要去检测
    document.addEventListener('pause', stopCount, false);
    document.addEventListener('resume', startCount, false);
    
    function stopCount() {
      if(ctrlCount) {
        clearTimeout(ctrlCount);
      }
    }
    
    function startCount() {
      mui.ylPost(
        {
          type: 'GetCountdown',
          examId: search.examId
        },
        function(data) {
          var data = data[0];
          if(data.state == '2') {
            mui.alert('考试时间已到,正在为您交卷！', function() {
              submitPage();
            });
          } else {
            startCountdown(data.countdown);
          }
        }
      );
    }
  }
  
});