/**
 * 获取学习状态
 */
function getStudyStatus() {
  mui.ylPost(
    {
      type: 'GetStatus'
    },
    function(data){
      var proportion = 100;
      if(data.totalNum > 0) {
        proportion = (data.studyNum / data.totalNum).toFixed(2) * 100;
      }
      $("#hasLearnNum").text('' + proportion);
      $("#totalNum").text('' + data.totalNum);
      $("#knowNum").text('' + data.num1);
      $("#vagueNum").text('' + data.num2);
      $("#unknowNum").text('' + data.num3);
    }
  );
}

/**
 * 获取题库
 */
function getTiku(){
  mui.ylPost(
    {
      type: 'GetWarehouse',
    },
    function(data){
      var tikuDiv = '';  
      
      if(data.length === 0) {
        Study.tikuID = undefined;
        hideDiv();
        showSidebar(false);
        $('#tiku-name').text('没有题库！');
        mui('body').off('tap', '#chooseTiku');
      }
      for(var i = 0; i < data.length; i++)
      {
        var itemTiku = new Tiku(data[i].id, data[i].name, data[i].totalNum, data[i].num1, data[i].num2, data[i].num3);
        Study.tikuList.push(itemTiku);
        tikuDiv += itemTiku.generate();
      }
      
      //show it
      $('#tikuDiv .singleChoice').after(tikuDiv);
      
      if(Study.tikuID != '')
      {
        var tikuIDList = Study.tikuID.split(',');
        for(var i=0;i<tikuIDList.length;i++)
        {
          $('#tikuDiv .tiku .statuBox[data-id=' + tikuIDList[i] + ']').addClass('active');
        }
      }
      
    }
  );
}

/**
 * 初始化题库
 */
function getHisStudy() {
  if(window.localStorage && window.localStorage.Study) {
    StudyInfo = JSON.parse(window.localStorage.Study);
    
    Study.tikuID = StudyInfo.tikuID;
    Study.typeID = StudyInfo.typeID;
    Study.statusID = StudyInfo.statusID;
    
    $('#tiku-name').text(clipTikuName(StudyInfo.tikuText));
    $('#type-name').text(StudyInfo.typeText);
    $('#master-name').text(StudyInfo.masterText);
    
    if(Study.typeID != '')
    {
      var typeIDList = Study.typeID.split(',');
      for(var i = 0; i < typeIDList.length; i++)
      {
        $('#typeDiv .multiChoice .statuBox[data-type=' + typeIDList[i] + ']').addClass('active');
      }
    }
    
    if(Study.statusID != '')
    {
      var statusIDList = Study.statusID.split(',');
      for(var i=0;i<statusIDList.length;i++)
      {
        $('#masterDiv .multiChoice .statuBox[data-statu=' + statusIDList[i] + ']').addClass('active');
      }
    }
  }
}

/**
 * 获取符合条件的数据总数
 */
function getTotalCount() {
  mui.ylPost(
    {
      type: 'SearchQuestionsForCount',
      whcode: Study.tikuID,
      chapcode: Study.zjID,
      qutype: Study.typeID,
      status: Study.statusID
    },
    function(data){
      $('#totalCount').text('符合条件的共有' + data + '题');
    }
  );
}

/**
 * 隐藏选择
 */
function hideDiv() {
  $("#loadImg").removeClass("show");
  $(".sidebar").removeClass("showLoad");
  $("#tikuDiv").removeClass("show");
  $("#typeDiv").removeClass("show");
  $("#masterDiv").removeClass("show");
}

/**
 * 显示侧边栏
 */
function showSidebar(choose)
{
  if(choose) {
    $(".cover").css('display','block');
    setTimeout(function(){$(".sidebar").addClass("show");},50);       
  }
  else {
    $(".sidebar").removeClass("show");
    setTimeout(function(){$(".cover").css('display','none');},500);
  }
};

/**
 * 按钮初始化
 */
function initButton() {
  mui('body').on('tap', '#refresh', function(){
    Study.clear();
    
    $('#tiku-name').text('未选择');
    $('#type-name').text('未选择');
    $('#master-name').text('未选择'); 
    $('#tikuDiv .tiku').remove();
    
    getStudyStatus();
    getTiku();
    getTotalCount();
    
  });
  
  mui('body').on('tap', '#orderStart', buttonEvent);
  mui('body').on('tap', '#randomStart', buttonEvent);
  
  function buttonEvent(){
    var isRandom = $(this).attr('id') === 'orderStart' ? false : true;
    //post and location
    mui.ylPost(
      {
        type: 'SearchQuestions',
        whcode: Study.tikuID,
        chapcode: Study.zjID,
        qutype: Study.typeID,
        status: Study.statusID,
        israndom: isRandom
      },
      function(data) {
        if(window.localStorage)
        {
          window.localStorage.removeItem(Study);
          window.localStorage.Study = JSON.stringify({
            tikuID: Study.tikuID,
            zjID: Study.zjID,
            typeID: Study.typeID,
            statusID: Study.statusID,
            tikuText: $('#tiku-name').text(),
            typeText: $('#type-name').text(),
            masterText: $('#master-name').text()
          });
        }
        
        if (data.count == 0) {
          $("#errorMsg").text("没有符合条件的题目");
          $("#totalCount").hide();
          $("#errorMsg").addClass("show");
          setTimeout(function(){$("#errorMsg").removeClass("show");$("#totalCount").show();},1000);
        } else {
          window.localStorage.studyList = data.list;
          openWindow('../study/startStudy.html?count=' + data.count);
        }
        
      }
    );
  }
}

// 选择框事件
function chooseCheck() {
  $(this).find(".statuBox").toggleClass("active");
}

var Study = {
  tikuID: '',
  typeID: '',
  statusID: '',
  lastTikuID: '',
  tikuList: Array(),
  findTiku: function(id) {
    
  },
  clear: function() {
    this.tikuID = '';
    this.typeID = '';
    this.statusID = '';
    this.tikuList = Array();
  }
};

/**
 * Class Tiku
 */
function Tiku(id,title,totalNum,knowNum,vagueNum,unknowNum)
{
  this.id = id;
  this.title = title;
  this.totalNum = totalNum;
  this.knowNum = knowNum;
  this.vagueNum = vagueNum;
  this.unknowNum = unknowNum;
  this.unLearnNum = totalNum - knowNum - vagueNum - unknowNum;
};

Tiku.prototype = {
  generate: function(){
    var tikuName = clipTiku(this.title);
    var mydiv = '<div class="tiku">' +
          '<div class="hbox">' +
            '<div class="statuBox iconfont" data-id="' + this.id + '"  data-title="' + this.title + '"></div>' +
            '<a class="tikuName">' + tikuName + '</a>' +
            '<div class="box-1" style="text-align: left;padding-left: 0.5rem;padding-top: 0.1rem;color: rgb(160,160,160);">' + '总题数&nbsp;' + this.totalNum + '</div>' +
          '</div>' +
          '<div class="hbox">' +
            '<div class="box-1">' +
              '<a class="number">' + this.knowNum + '</a>' +
              '<a class="title"><span class="iconfont">&#xe62c;</span>认识</a>' +
            '</div>' +
            '<div class="box-1">'+
              '<a class="number">' + this.vagueNum + '</a>' +
              '<a class="title"><span class="iconfont">&#xe62b;</span>模糊</a>' +
            '</div>'+
            '<div class="box-1">' +
              '<a class="number">' + this.unknowNum + '</a>' +
              '<a class="title"><span class="iconfont">&#xe62d;</span>忘记</a>' +
            '</div>'+
            '<div class="box-1">' +
              '<a class="number">' + this.unLearnNum + '</a>' +
              '<a class="title"><span class="iconfont" style="font-size: 0.8rem">&#xe631;</span>未学习</a>'+
            '</div>'+
          '</div></div>';
    return mydiv;
  }
}

/**
 * 初始化学习
 */
function initReadyStudy() {
  mui('body').on('tap', '.cover', function(){
    showSidebar(false);
  });
  
  getStudyStatus();
  getHisStudy();
  getTotalCount();
  getTiku();
  initButton();
  
  mui('#tikuDiv').on('tap', '.tiku', chooseCheck);
  
  window.addEventListener('refresh', function() {
    getStudyStatus();
    getTotalCount();
  });
  
  //类型选择和掌握情况初始化
  (function(){
    
    mui('body').on('tap', '.multiChoice', chooseCheck);
    
    mui('#typeDiv').on('tap', 'button', function(){
      var typeText = '';
      var lastTypeID = Study.typeID;
      Study.typeID = '';
      $('#typeDiv .multiChoice .statuBox.active').each(activeEach);
      //remove last ,
      if(Study.typeID != '')
      {
        Study.typeID = Study.typeID.substr(0,Study.typeID.length-1);
        typeText = typeText.substr(0,typeText.length-1);
      }
      else
      {
        typeText = '未选择';
      }
      
      $('#type-name').text(typeText);
      
      //refreshtotalCount
      if(lastTypeID!=Study.typeID)
      {
        getTotalCount();
      }
      
      showSidebar(false);
      
      function activeEach()
      {
        Study.typeID += $(this).attr('data-type') + ',';
        switch($(this).attr('data-type'))
        {
          case '1': typeText += '判断题，'; break;
          case '2': typeText += '单选题，'; break;
          case '3': typeText += '多选题，'; break;
        }
      }
    });

    mui('#masterDiv').on('tap', 'button', function(){
      //get status
      var statusText = '';
      
      var lastStatusID = Study.statusID;
      //clear status array
      Study.statusID = '';
      $('#masterDiv .multiChoice .statuBox.active').each(function(){
        Study.statusID += $(this).attr('data-statu') + ',';
        switch($(this).attr('data-statu'))
        {
          case '1': statusText += '认识，'; break;
          case '2': statusText += '模糊，'; break;
          case '3': statusText += '忘记，'; break;
          case '0': statusText += '未学习，'; break;
        }
      });
      //remove last ','
      if(Study.statusID != '')
      {
        Study.statusID = Study.statusID.substr(0,Study.statusID.length-1);
        statusText = statusText.substr(0,statusText.length-1);
      }
      else//if choose null
      {
        statusText = '未选择';
      }
      
      $('#master-name').text(statusText);
      //refreshtotalCount
      if(lastStatusID!=Study.statusID)
      {
        getTotalCount();
      }
      
      showSidebar(false);
      
    });
    mui('#tikuDiv').on('tap', '.singleChoice', function(){
      
      if($('#tikuDiv .singleChoice').find('.statuBox').hasClass('active'))
        $('#tikuDiv').find('.statuBox').removeClass('active');
      else
        $('#tikuDiv').find('.statuBox').addClass('active');
    });
    
    mui('#tikuDiv').on('tap', 'button', function(){
      var lastTikuID = Study.tikuID;
      //clear tikuId
      Study.tikuID = '';
      tikuText = '';
      $('#tikuDiv .tiku .statuBox.active').each(activeEach);
      //remove last ,
      if(Study.tikuID != '')
      {
        Study.tikuID = Study.tikuID.substr(0,Study.tikuID.length-1);
        tikuText = tikuText.substr(0,tikuText.length-1);
      }
      else
      {
        tikuText = '未选择';
      }
      $('#tiku-name').text(clipTikuName(tikuText));
      if(lastTikuID != Study.tikuID)
      {
        getTotalCount();  
      }
      
      showSidebar(false);
      
      function activeEach()
      {
        tikuText += $(this).attr('data-title')+'，';
        Study.tikuID += $(this).attr('data-id')+',';
      }
    });
    
  })();
  
}

function clipTikuName(name) {
  if(name.length > 16) {
    return name.substr(0, 15) + '...';
  } else {
    return name;
  }  
}

function clipTiku(name) {
  if(name.length > 9) {
    return name.substr(0, 8) + '...';
  } else {
    return name;
  }
}
