var opener = null;

/**
 * 按钮初始化
 */
function initButton() {
  
  mui('body').on('tap', '#btn-back', function(){
    mui.fire(opener, 'refresh', {});
    mui.back();
  });
  
  mui('#buttonDiv').on('tap', 'button', buttonClick);
  
  function buttonClick() {
    subjectList.direction = 1;
    
    $('.cover').addClass('ln-show');
    
    //update question
    if ($(this).attr('data-status') != subjectList.nowSubject.status) {
      var updateStatus = $(this).attr('data-status');
      mui.ylPost(
        {
          quCode: subjectList.nowSubject.id,
          status: updateStatus,
          type: 'Study'
        },
        function(data)
        {}
      );
    }
    //next subject is ready?
    nextSubjectReady();
    function nextSubjectReady()
    {
      //if no next subject
      if(subjectList.nextIndex > subjectList.count)
      {
        $('.cover .tips').show();
        $('.cover').css('background', 'rgba(0,0,0,0.6)');
        $('.cover #load').hide();
        mui('body').on('tap', '.tips', function(){
          mui.fire(opener, 'refresh', {});
          mui.back();
        });
      }
      else{
        //if next subjct not ready
        if(subjectList.nextSubject == null)
        {
          setTimeout(nextSubjectReady, 300);
        }
        else
        {
          showAnswer(false);
          setTimeout(function(){$(".cover").removeClass("ln-show")},200);
          
          subjectList.preSubject = subjectList.nowSubject;
          subjectList.nowSubject = subjectList.nextSubject;
          subjectList.nowSubject.fillContent();

          var nextIndex = subjectList.findIndex(subjectList.nextSubject);
          if (nextIndex == 4 || subjectList.me.length<=5) { 
            subjectList.nextSubject = null;
            getSubject();
          } else {
            subjectList.nextSubject = subjectList.me[nextIndex+1];
          }
        }
      }
    } // end of nextSubjectReady
  }// end of buttonclick
  
}

/**
 * 返回上一题
 */
function goPreSubject()
{
  //显示0.3s的过度页面
  $(".cover").addClass("ln-show");

  subjectList.direction = -1;
  preSubjectReady();

  function preSubjectReady () {

    if(subjectList.nowSubject.id == subjectList.list[0])
    {
      $(".cover #load").hide();
      $(".cover").append("<div id='errorMsg'>前面没有了</div>");
      setTimeout(function(){
        $(".cover").removeClass("ln-show");
        $(".cover #errorMsg").remove();
        $(".cover #load").show();
      },600);
      return;
    }
    if(subjectList.preSubject == null)
    {
      setTimeout(preSubjectReady,300);
      return;
    }

    subjectList.nextSubject = subjectList.nowSubject;
    subjectList.nowSubject = subjectList.preSubject;
    subjectList.nextIndex--;

    var nowIndex = subjectList.findIndex(subjectList.nowSubject);
    if(nowIndex == 0)
    {
      //if no pre
      if(subjectList.preSubject.id != subjectList.list[0])
        getSubject();
      subjectList.preSubject = null;
    }
    else
    {
      subjectList.preSubject = subjectList.me[nowIndex-1];
    }
    subjectList.nowSubject.fillContent();
    showAnswer(true);
    setTimeout(function(){$(".cover").removeClass("ln-show");},200);
  }
}

/**
 * 获取题目
 */
function getSubject()
{ 
  var subjectIndex;
  if(subjectList.direction==1)
  {
    subjectIndex = subjectList.nextIndex;
  }
  else
  {
    subjectIndex = subjectList.nextIndex - 3;
  }
  
  mui.ylPost(
    {
      type: 'GetQuestions',
      quCode: subjectList.list[subjectIndex]
    },
    function(data)
    {
      var options = Array();
      for(var i=1;i<=6;i++)
      {
        if(data['option'+i] && typeof data['option'+i]!='object')
        options.push(data['option'+i]);
      }
      var tempSubject = new Subject(data.code, data.title, options, data.answer, data.explain,
                                    data.basis, data.status, data.type);
                                    
      subjectList.pushSubject(tempSubject);
      
      if(subjectList.direction == 1){
        subjectList.nextSubject = null;
        subjectList.nextSubject = tempSubject;
        subjectList.nextIndex++;
      }
      else
      {
        subjectList.preSubject = tempSubject;
      }
      if(subjectList.nowSubject==null)
      {
        subjectList.nowSubject = subjectList.nextSubject;
        subjectList.nowSubject.fillContent();
        setTimeout(function(){$(".cover").removeClass("ln-show")},200);
        getSubject();
      }
    },
    function(){
      subjectList.nextSubject = null;
      subjectList.nextIndex ++;
      if(subjectList.nextIndex >= subjectList.list.length)
      {
        //no next subject
      }
      else
      {
        getSubject();
      }
    }
  );
};

var subjectList =
{
  list: Array(),
  count: undefined,
  nextIndex : 0,
  preIndex : 0,
  nextSubject : null,
  nowSubject : null,
  preSubject : null,
  me: [],
  direction: 1,
  findIndex: function(obj){
    for(var i = 0, len = this.me.length; i<len; i++)
    {
      if(obj === this.me[i])
      {
        return i;
      }
    }
  },
  pushSubject : function(subject){
    //every time get subject, add to subjectList
    if(this.direction == 1)
      this.me.push(subject);
    else
      this.me.unshift(subject);
    //if subjectList.me is larger than 5, remove the last one
    if(this.me.length > 5)
    {
      if(this.direction == 1)
      {
        this.me.shift();
      } else {
        this.me.pop();
      }
    }
  }
};

/**
 * 学习初始化
 */
function startStudyInit()
{
  initPage();
  
  opener = plus.webview.currentWebview().opener();
  
  subjectList.list = window.localStorage.studyList.split(',');
  subjectList.count = getSearchArgs().count;
  
  $('#nowNum').text(1);
  $('#totalNum').text(subjectList.count);
  
  getSubject();
  initButton();
  showAnswer(false);
  
  mui('body').on('tap', '#coverAnswer', function() {showAnswer(true)});  
  mui('body').on('tap', '#goPre', goPreSubject);
  
};


/**
 * class subject and function
 */
function Subject(id, title, options, answer, explain, rely, status, type)
{
  this.title = title;
  this.id = id;
  this.options = options;
  this.answer = answer;
  this.explain = explain;
  this.rely = rely;
  this.status = status;
  this.type = type;
  this.fillContent = fillDiv;
};
function fillDiv()
{
  if(subjectList.direction==1)
    $('#nowNum').text(subjectList.nextIndex);
  else
    $('#nowNum').text(subjectList.nextIndex-1);
  
  switch(this.status)
  {
    case '0':$('#lastStatus').text('未学习');break;
    case '1':$('#lastStatus').text('认识');break;
    case '2':$('#lastStatus').text('模糊');break;
    case '3':$('#lastStatus').text('忘记');break;
  }
  switch(this.type)
  {
      case "1": $('#questionType').text('判');break;
      case "2": $('#questionType').text('单');break;
      case "3": $('#questionType').text('多');break;
  }
  $('#questionTitle').html(this.title);
  var pDiv = '';


  for(var i = 0; i < this.options.length; i++)
  {
    pDiv += '<p id="option' + (i + 1) + '">' + this.options[i] + '</p>';
  }

  $('#questionDiv p').remove();
  $('#questionDiv').append(pDiv);

  document.getElementById('answer').innerHTML = this.answer;
  document.getElementById('explain').innerHTML = this.explain;
  document.getElementById('rely').innerHTML = this.rely;
};

function showAnswer(show)
{
  if(show)
  {
    document.getElementById('coverAnswer').classList.add('hide');
    document.getElementById('answerDiv').classList.remove('hide');
    var answer = subjectList.nowSubject.answer;
    var type = subjectList.nowSubject.type;

    //答案颜色标亮 A B C D 对 错
    if(answer.indexOf('A') != -1 || answer.indexOf('对')!= -1 || answer.indexOf('a') != -1)
      $('#option1').css('color','#F56C43');
    if(answer.indexOf('B') != -1 || answer.indexOf('错') != -1 || answer.indexOf('b') != -1)
      $("#option2").css('color','#F56C43');
    if(answer.indexOf('C') != -1 || answer.indexOf('c') != -1)
      $("#option3").css('color','#F56C43');
    if(answer.indexOf('D') != -1 || answer.indexOf("d") != -1)
      $("#option4").css('color','#F56C43');
    
  }
  else
  {
    document.getElementById("answerDiv").classList.add("hide");
    document.getElementById("coverAnswer").classList.remove("hide");
  }
};